/*	libgemwidget - Gtk+ Embedded Widget library
 *
 *	Authors: YE Nan <nan.ye@orange-ftgourp.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef __GEM_HASH_VIEW_CELL_H
#define __GEM_HASH_VIEW_CELL_H

#include <glib.h>

#ifdef __cplusplus
extern "C" {
#endif

#define	GEM_TYPE_HASH_VIEW_CELL							(gem_hash_view_cell_get_type ())
#define	GEM_HASH_VIEW_CELL(obj)							(G_TYPE_CHECK_INSTANCE_CAST ((obj), GEM_TYPE_HASH_VIEW_CELL, GemHashViewCell))
#define GEM_HASH_VIEW_CELL_CLASS(klass)			(G_TYPE_CHECK_CLASS_CAST ((klass), GEM_TYPE_HASH_VIEW_CELL, GemHashViewCellClass))
#define	GEM_IS_HASH_VIEW_CELL(obj)					(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEM_TYPE_HASH_VIEW_CELL))
#define GEM_HASH_VIEW_CELL_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), GEM_TYPE_HASH_VIEW_CELL, GemHashViewCellClass))

typedef struct _GemHashViewCell					GemHashViewCell;
typedef struct _GemHashViewCellClass		GemHashViewCellClass;

struct _GemHashViewCell {
	GtkViewport				parent;
};

struct _GemHashViewCellClass {
	GtkViewportClass				parent_class;
	
	void										(*set_value)					(GemHashViewCell		*cell,
																								 const gchar				*val);
	G_CONST_RETURN	gchar *	(*get_value)					(GemHashViewCell		*cell);
	
	gboolean								(*get_visible)				(GemHashViewCell		*cell);
	void										(*set_visible)				(GemHashViewCell		*cell,
																								 gboolean						 editable);

	gboolean								(*get_editable)				(GemHashViewCell		*cell);
	void										(*set_editable)				(GemHashViewCell		*cell,
																								 gboolean						 editable);

	gboolean								(*get_focus)					(GemHashViewCell		*cell);
	void										(*set_focus)					(GemHashViewCell		*cell);
	
	/* Padding for future extension */
	void		(*_gem_reserved1)	(void);
	void		(*_gem_reserved2)	(void);
	void		(*_gem_reserved3)	(void);
	void		(*_gem_reserved4)	(void);
};

GType											gem_hash_view_cell_get_type						(void)	G_GNUC_CONST;

G_CONST_RETURN	gchar *		gem_hash_view_cell_get_value					(GemHashViewCell		*cell);
void											gem_hash_view_cell_set_value					(GemHashViewCell		*cell,
																																 const gchar				*val);

gboolean									gem_hash_view_cell_get_visible				(GemHashViewCell		*cell);
void											gem_hash_view_cell_set_visible				(GemHashViewCell		*cell,
																																 gboolean						 visualizable);
																								 
gboolean									gem_hash_view_cell_get_editable				(GemHashViewCell		*cell);
void											gem_hash_view_cell_set_editable				(GemHashViewCell		*cell,
																																 gboolean						 editable);

gboolean									gem_hash_view_cell_get_focus					(GemHashViewCell		*cell);
void											gem_hash_view_cell_set_focus					(GemHashViewCell		*cell);
																							
#ifdef __cplusplus
}
#endif

#endif /*__GEM_HASH_VIEW_CELL_H*/

/*
vi:ts=2:nowrap:ai:expandtab 
*/
