/*	libgemwidget - Gtk+ Embedded Widget library
 *
 *	Authors: YE Nan <nan.ye@orange-ftgourp.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef __GEM_NOTIFICATION_H
#define __GEM_NOTIFICATION_H

#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif

#define	GEM_TYPE_NOTIFICATION							(gem_notification_get_type ())
#define	GEM_NOTIFICATION(obj)							(G_TYPE_CHECK_INSTANCE_CAST ((obj), GEM_TYPE_NOTIFICATION, GemNotification))
#define	GEM_NOTIFICATION_CLASS(klass)			(G_TYPE_CHECK_CLASS_CAST ((klass), GEM_TYPE_NOTIFICATION, GemNotificationClass))
#define	GEM_IS_NOTIFICATION(obj)					(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEM_TYPE_NOTIFICATION))
#define GEM_IS_NOTIFICATION_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GEM_TYPE_NOTIFICATION))
#define GEM_NOTIFICATION_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), GEM_TYPE_NOTIFICATION, GemNotificationClass))
	
typedef struct _GemNotification					GemNotification;
typedef struct _GemNotificationClass		GemNotificationClass;

struct _GemNotification
{
	GtkWindow				 window;
	GtkWidget				*text_nc;
	GtkWidget				*graphic_nc;
	GtkWidget				*progress_nc;
	
	gdouble					 fraction;
	guint						 timeout;
	
	gboolean				 hide_text;
	gboolean				 hide_graphic;
	gboolean				 hide_progress;
};

struct _GemNotificationClass
{
	GtkWindowClass parent_class;
};

GType						gem_notification_get_type								(void) G_GNUC_CONST;
GtkWidget*			gem_notification_new										(void);
void						gem_notification_set_image_from_file		(GemNotification		*window,
																												 const gchar				*fname);
void						gem_notification_set_text								(GemNotification		*window,
																												 const gchar				*text);
void						gem_notification_set_progross_fraction	(GemNotification		*window,
																												 gdouble						 fraction);

void						gem_notification_hide_text							(GemNotification		*window);
void						gem_notification_hide_graphic						(GemNotification		*window);
void						gem_notification_hide_progressbar				(GemNotification		*window);

																														 
#endif /*__GEM_NOTIFICATION_H*/

/*
vi:ts=2:nowrap:ai:expandtab 
*/
