/*  addressbook - Address book
 *abooknumchooser.h -
 *
 *Authors: YE Nan <nan.ye@orange-ftgroup.com>
 *        ZHAO Liangjing <liangjing.zhao@orange-ftgroup.com>
 *
 *This software and associated documentation files (the "Software")
 *are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom]
 *All Rights Reserved.
 *
 *A copyright license is hereby granted for redistribution and use of
 *the Software in source and binary forms, with or without modification,
 *provided that the following conditions are met:
 *- Redistributions of source code must retain the above copyright notice,
 *this copyright license and the following disclaimer.
 *- Redistributions in binary form must reproduce the above copyright
 *notice, this copyright license and the following disclaimer in the
 *documentation and/or other materials provided with the distribution.
 *- Neither the name of LiPS  nor the names of its Members may be used
 *to endorse or promote products derived from the Software without
 *specific prior written permission.
 *
 *A patent license for any Necessary Claims owned by Members of LiPS Forum
 *to make, have made, use, import, offer to sell, lease and sell or otherwise
 *distribute any implementation compliant with the any specification adopted
 *by the LiPS Forumcan be obtained from the respective Members on reasonable
 *and non-discriminatory terms and conditions and under reciprocity, as
 *regulated in more detail in the Internal Policy of the LiPS Forum.
 *
 *THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS
 *"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
 *AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER,
 *ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *POSSIBILITY OF SUCH DAMAGE.
 */


#ifndef ABOOK_NUMCHOOSER_H_
#define ABOOK_NUMCHOOSER_H_

#include <gtk/gtk.h>

#include "gtkautoscrolledwindow.h"

#ifdef __cplusplus
extern "C"
{
#endif

  typedef enum
  {
    COL_NC_TYPE,
    COL_NC_NUMBER,
    NUM_NC_COLS
  } ABookNumberChooserCols;

#define	ABOOK_TYPE_NUMBER_CHOOSER							(abook_number_chooser_get_type ())
#define	ABOOK_NUMBER_CHOOSER(obj)							(G_TYPE_CHECK_INSTANCE_CAST ((obj), ABOOK_TYPE_NUMBER_CHOOSER, ABookNumberChooser))
#define	ABOOK_NUMBER_CHOOSER_CLASS(klass)			(G_TYPE_CHECK_CLASS_CAST ((klass), ABOOK_TYPE_NUMBER_CHOOSER, ABookNumberChooserClass))
#define	ABOOK_IS_NUMBER_CHOOSER(obj)					(G_TYPE_CHECK_INSTANCE_TYPE ((obj), ABOOK_TYPE_NUMBER_CHOOSER))
#define ABOOK_IS_NUMBER_CHOOSER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), ABOOK_TYPE_NUMBER_CHOOSER))
#define ABOOK_NUMBER_CHOOSER_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), ABOOK_TYPE_NUMBER_CHOOSER, ABookNumberChooserClass))

  typedef struct _ABookNumberChooser ABookNumberChooser;
  typedef struct _ABookNumberChooserClass ABookNumberChooserClass;

  struct _ABookNumberChooser
  {
    GtkDialog view;

    GtkWidget *scroll_window;
    GtkWidget *treeview;
    GtkListStore *liststore;
  };

  struct _ABookNumberChooserClass
  {
    GtkDialogClass parent_class;
  };

  GType abook_number_chooser_get_type (void) G_GNUC_CONST;
  GtkWidget *abook_number_chooser_new (void);
  GtkListStore *abook_number_chooser_get_model (ABookNumberChooser *view);
  GtkWidget *abook_number_chooser_get_view (ABookNumberChooser *view);
  void abook_number_chooser_update (ABookNumberChooser *view);
  gchar *abook_number_chooser_get_selected (ABookNumberChooser *view);

#ifdef __cplusplus
}
#endif
#endif                          /* ABOOK_NUMBER_CHOOSER_H_ */

/* 
vi:ts=2:nowrap:ai:expandtab
*/

