/*	libgemwidget - Gtk+ Embedded Widget library
 *
 *	Authors: YE Nan <nan.ye@orange-ftgourp.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef	__GTK_AUTOSCROLLED_WINDOW_H_
#define	__GTK_AUTOSCROLLED_WINDOW_H_

#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif

#define	GTK_TYPE_AUTO_SCROLLED_WINDOW									(gtk_auto_scrolled_window_get_type ())
#define	GTK_AUTO_SCROLLED_WINDOW(obj)									(G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_TYPE_AUTO_SCROLLED_WINDOW, GtkAutoScrolledWindow))
#define	GTK_AUTO_SCROLLED_WINDOW_CLASS(klass)					(G_TYPE_CHECK_CLASS_CAST ((klass), GTK_TYPE_AUTO_SCROLLED_WINDOW, GtkAutoScrolledWindowClass))
#define	GTK_IS_GTK_AUTO_SCROLLED_WINDOW(obj)					(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_TYPE_AUTO_SCROLLED_WINDOW))
#define GTK_IS_GTK_AUTO_SCROLLED_WINDOW_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GTK_TYPE_AUTO_SCROLLED_WINDOW))
#define GTK_AUTO_SCROLLED_WINDOW_GET_CLASS(obj)				(G_TYPE_INSTANCE_GET_CLASS ((obj), GTK_TYPE_AUTO_SCROLLED_WINDOW, GtkAutoScrolledWindowClass))

typedef struct _GtkAutoScrolledWindow				GtkAutoScrolledWindow;
typedef struct _GtkAutoScrolledWindowClass	GtkAutoScrolledWindowClass;

struct _GtkAutoScrolledWindow
{
	GtkFrame						frame;
	
	GtkWidget						*scrolledwindow;
	GtkWidget						*child;
};

struct _GtkAutoScrolledWindowClass
{
	GtkFrameClass	parent_class;
};


GType			gtk_auto_scrolled_window_get_type								(void)	G_GNUC_CONST;
GtkWidget*	gtk_auto_scrolled_window_new										(void);

void				gtk_auto_scrolled_window_add_with_viewpoert			(GtkAutoScrolledWindow	*ac_window, 
																														 GtkWidget							*widget);
																														 
void				gtk_auto_scrolled_window_add										(GtkAutoScrolledWindow	*ac_window, 
																														 GtkWidget							*widget);

#ifdef __cplusplus
}
#endif

#endif /*__GTK_AUTOSCROLLED_WINDOW_H_*/

/*
vi:ts=2:nowrap:ai:expandtab 
*/
