/*	libgemwidget - Gtk+ Embedded Widget library
 *
 *	Authors: YE Nan <nan.ye@orange-ftgourp.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef	__GTK_TIME_EDIT_H_
#define	__GTK_TIME_EDIT_H_

#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif

#define	GTK_TYPE_TIME_EDIT									(gtk_time_edit_get_type ())
#define	GTK_TIME_EDIT(obj)									(G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_TYPE_TIME_EDIT, GtkTimeEdit))
#define	GTK_TIME_EDIT_CLASS(klass)					(G_TYPE_CHECK_CLASS_CAST ((klass), GTK_TYPE_TIME_EDIT, GtkTimeEditClass))
#define	GTK_IS_GTK_TIME_EDIT(obj)						(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_TYPE_TIME_EDIT))
#define GTK_IS_GTK_TIME_EDIT_CLASS(klass)		(G_TYPE_CHECK_CLASS_TYPE ((klass), GTK_TYPE_TIME_EDIT))
#define GTK_TIME_EDIT_GET_CLASS(obj)				(G_TYPE_INSTANCE_GET_CLASS ((obj), GTK_TYPE_TIME_EDIT, GtkTimeEditClass))

typedef struct _GtkTimeEdit				GtkTimeEdit;
typedef struct _GtkTimeEditClass		GtkTimeEditClass;

struct _GtkTimeEdit
{
	GtkHBox						  hbox;
	
	GtkWidget 					*pad1;
	GtkWidget 					*entry1;  //For input hour
	GtkWidget 					*entry2;  //For input minute
	GtkWidget 					*pad2;
	
	GtkWidget 					*eventbox;
	GtkWidget 					*label;
};

struct _GtkTimeEditClass
{
	GtkHBoxClass	parent_class;
	
	
	
};

enum {
  HOUR_ENTRY = 0,
  MIN_ENTRY = 1
};


GType				gtk_time_edit_get_type								(void)	G_GNUC_CONST;
GtkWidget*	gtk_time_edit_new										(void);


void 				gtk_time_edit_set_widget_width			(GtkTimeEdit 	*entry,
																								guint 					pad1w, 
																								guint 					entry1w,
																								guint 					entry2w,
																								guint						pad2w);

void				gtk_time_edit_set_value							(GtkTimeEdit  *dateedit,
																								guint						hour,
																								guint						min);

guint				gtk_time_edit_get_hour							(GtkTimeEdit  *dateedit);
guint				gtk_time_edit_get_min  							(GtkTimeEdit  *dateedit);
																													 


#ifdef __cplusplus
}
#endif

#endif /*__GPE_TIME_EDIT_H_*/

/*
vi:ts=2:nowrap:ai:expandtab 
*/
