#include <gemfilechooser.h>
#include <libgnomevfs/gnome-vfs.h>
#include <libgnomevfs/gnome-vfs-mime.h>
#include <libgnomevfs/gnome-vfs-mime-handlers.h>
#include <libgnomevfs/gnome-vfs-mime-info.h>
#include <libgnomevfs/gnome-vfs-types.h>
#include <libgnomevfs/gnome-vfs-application-registry.h>
#include <gemresource.h>
#include <gemenv.h>
#include <gtk/gtk.h>
#include <gpe/gpeskwindow.h>
#include <gpe/init.h>
#include <gpe/errorbox.h>
#include <gpe/pixmaps.h>
#include <gpe/picturebutton.h>
#include <gpe/question.h>
#include <gpe/gpeiconlistview.h>
#include <gpe/spacing.h>
#include <gpe/gpehelp.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <string.h>

#define _(x) dgettext(PACKAGE_NAME,x)
#define DEFAULT_TERMINAL "rxvt -e"
#include "../config.h"
#ifndef DBGING 
#define DBGING 1
#define DBG(x...) do { if(DBGING) { \
                           g_print("%s(%d):", __FUNCTION__, __LINE__); \
                           g_print(x);    \
                           g_print("\n"); \
                      } \
                      }while(0)
#endif
GList *file_clipboard = NULL;
GtkWidget *window = NULL;//= gpe_skwindow_new ();
gboolean MARK = FALSE;
gchar *virtual_root;
static GtkUIManager *ui_manager = NULL;
static GtkActionGroup *action_group = NULL;
static gboolean abort_transfer = FALSE;
static GtkWidget *progress_dialog = NULL;
static GList *dirlist = NULL;
static GnomeVFSResult
delete_directory_recursive (gchar *file_name);
static gint
transfer_callback (GnomeVFSXferProgressInfo * info, gpointer data);
gboolean
delete_cb_recursive ( const gchar * rel_path,
	              	    GnomeVFSFileInfo * info,
              		    gboolean recursing_will_loop,
		                  gpointer data, 
											gboolean * recurse
										);
static void
clip_one_file (gpointer data,gpointer user_data);
void 
paste_file_clip(GtkActionGroup *action_group,gpointer data);
static void
copy_one_file (gpointer file, gpointer userdata);
const gchar *
get_the_copy_name (gchar * the_copy_name);

static void
delete_one_file (gpointer data,gpointer user_data);
static void
clear_clipboard (void)
{
  GList *iter = file_clipboard;
  if (!file_clipboard)
    return;
  while (iter)
    iter = iter->next;
  g_list_free (file_clipboard);
  file_clipboard = NULL;
}

static void
progress_response (GtkDialog * dialog, gint arg1, gpointer user_data)
{
  abort_transfer = TRUE;
}
static GtkWidget *
progress_dialog_create (gchar * title)
{
  GtkWidget *dialog;
  GtkWidget *progress;
  window = gtk_window_new(GTK_WINDOW_POPUP);
  dialog = gtk_dialog_new_with_buttons ( title, GTK_WINDOW (window),
                                				 GTK_DIALOG_MODAL |
					                               GTK_DIALOG_DESTROY_WITH_PARENT,
					                               GTK_STOCK_CANCEL, 
																				 GTK_RESPONSE_CANCEL,
					                               NULL
																			 );
  progress = gtk_progress_bar_new ();
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),progress, FALSE, TRUE, 0);
  g_object_set_data (G_OBJECT (dialog), "bar", progress);
  g_signal_connect (G_OBJECT (dialog), "response", G_CALLBACK (progress_response), NULL);
  gtk_widget_show_all (dialog);
  return dialog;
}
static void
cb_softkey_action (GpeSKWindow * window, gint nr, gpointer user_data)
{
  
	
  if (nr == 0)
  {
    const gchar *current_path = gem_file_chooser_get_current_path(user_data);	  
    GList *sel = NULL;
      sel = gem_file_chooser_get_current_selections(user_data);
    if(!strcmp(current_path,virtual_root))
    {
      GtkAction *action = gtk_action_group_get_action(action_group,"copy_file_or_dir");
      gtk_action_set_visible(action,FALSE);		
      action = gtk_action_group_get_action(action_group,"paste_file_or_dir");
      gtk_action_set_visible (action,FALSE);		
      action = gtk_action_group_get_action(action_group,"delete_file_or_dir");
      gtk_action_set_visible (action,FALSE);		
      action = gtk_action_group_get_action(action_group,"open_file_or_dir");
      gtk_action_set_visible(action,TRUE);		
      if(sel == NULL)
        gtk_action_set_visible(action,FALSE);		
      else
        gtk_action_set_sensitive(action,TRUE);		
      action = gtk_action_group_get_action(action_group,"select");
      gtk_action_set_visible(action,FALSE);		
      return;
    }
    else
    {
      GtkAction *action = gtk_action_group_get_action(action_group,"copy_file_or_dir");
      gtk_action_set_visible(action,TRUE);		
      action = gtk_action_group_get_action(action_group,"paste_file_or_dir");
      gtk_action_set_visible(action,TRUE);		
      action = gtk_action_group_get_action(action_group,"delete_file_or_dir");
      gtk_action_set_visible(action,TRUE);		
      action = gtk_action_group_get_action(action_group,"select");
      gtk_action_set_visible(action,TRUE);		

      if(sel == NULL)
      {
        action = gtk_action_group_get_action(action_group,"copy_file_or_dir");
        gtk_action_set_sensitive (action,FALSE);		
        action = gtk_action_group_get_action(action_group,"delete_file_or_dir");
        gtk_action_set_sensitive (action,FALSE);		
			  action = gtk_action_group_get_action(action_group,"open_file_or_dir");
        gtk_action_set_sensitive (action,FALSE);		
        action = gtk_action_group_get_action(action_group,"select");
        gtk_action_set_sensitive (action,TRUE);		
      }
      else
      {
			  action = gtk_action_group_get_action(action_group,"open_file_or_dir");
			  if(g_list_length(sel) > 1)
          gtk_action_set_sensitive (action,FALSE);		
			  else
          gtk_action_set_sensitive (action,TRUE);		
				
				action = gtk_action_group_get_action(action_group,"copy_file_or_dir");
        gtk_action_set_sensitive (action,TRUE);		
        action = gtk_action_group_get_action(action_group,"paste_file_or_dir");
        gtk_action_set_sensitive (action,TRUE);		
        action = gtk_action_group_get_action(action_group,"delete_file_or_dir");
        gtk_action_set_sensitive (action,TRUE);		
        action = gtk_action_group_get_action(action_group,"select");
        gtk_action_set_sensitive (action,TRUE);		
      }
	  }   
  }
  if (nr == 1)
  {   
    gnome_vfs_shutdown (); 
    gtk_exit(0);
  }
}

static GnomeVFSResult
delete_directory_recursive (gchar *file_name)
{
  gchar *path = g_strdup (file_name);
  GList *iter;
  gnome_vfs_directory_visit ( file_name,
			                        GNOME_VFS_FILE_INFO_DEFAULT,
			                        GNOME_VFS_DIRECTORY_VISIT_DEFAULT,
			                        (GnomeVFSDirectoryVisitFunc) delete_cb_recursive,
			                        path
														);
 	g_free (path);
  iter = dirlist;
  while (iter)
  {
    gnome_vfs_remove_directory (iter->data);
		g_free (iter->data);
    iter = iter->next;
  }
  g_list_free (dirlist);
  dirlist = NULL;
  GnomeVFSResult r=gnome_vfs_remove_directory_from_uri (gnome_vfs_uri_new (file_name));
  return r;
}


static void
open_with (GnomeVFSMimeApplication * application, gchar *filename)
{
  pid_t pid;
  if (application)
  {
    gchar *msg = g_strdup_printf ("%s %s", "Starting", application->name);
    Display *dpy = GDK_DISPLAY ();
    
    //gpe_popup_infoprint (dpy, msg);
    g_free (msg);
    pid = fork ();
    switch (pid)
  	{
	    case    -1:
	            return;		/* failed */
	            break;
	    case    0:
	            if (application->requires_terminal)
							{
							  DBG("************************application->command=%s",application->command);
                DBG("filename=%s",filename);
								execlp (DEFAULT_TERMINAL, DEFAULT_TERMINAL, application->command, filename, NULL);
							  perror("111_______________________");  
							}
	            else
							{
							  DBG("****************application->command=%s",application->command);
                DBG("filename=%s",filename);
								execlp (application->command, application->command, filename, NULL);
							  perror("22222222222_______________________");  
							}
	            exit (-1);		/* die in case of failing to exec */
	            break;
	    default:
	            break;
	  }
  }
}
static void
popup_ask_open_file(GtkActionGroup *action_group,gpointer user_data)
{

  GtkWidget *dialog_window, *combo, *label, *entry;
  GtkWidget *open_button, *cancel_button;
  GList *applications = NULL;
  GList *appnames = NULL;
  gchar *s;
	GList *sel = NULL;
	sel = gem_file_chooser_get_current_selections_vfs_file_info(user_data);
	if((sel ==  NULL)||(g_list_length(sel) > 1))
		return;
  const gchar *current_path = gem_file_chooser_get_current_path(user_data); 
  
	DBG("CP=%s",current_path);
	GList *first = NULL;
	first = g_list_first(sel);
	if(first == NULL)
		return;
	GnomeVFSFileInfo *vfs_file_info = first->data;

	gchar *file_name = g_strdup_printf("%s/%s",current_path,vfs_file_info->name);
	DBG("FILE_NAME=%s",file_name);
  if(vfs_file_info->type == GNOME_VFS_FILE_TYPE_DIRECTORY)
  {
    gem_file_chooser_set_current_path(user_data,file_name);
	  return;	
	}
	dialog_window = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog_window), "Open With...");
  gtk_window_set_transient_for (GTK_WINDOW (dialog_window),
				GTK_WINDOW (window));
  gtk_window_set_modal (GTK_WINDOW (dialog_window), TRUE);

  label = gtk_label_new (NULL);
  s = g_strdup_printf ("<b>%s</b>", "Open with program");
  gtk_label_set_markup (GTK_LABEL (label), s);
  g_free (s);

  gtk_misc_set_alignment (GTK_MISC (label), 0.0, 0.5);

  entry = gtk_entry_new ();

  combo = gtk_combo_new ();
  gtk_combo_set_value_in_list (GTK_COMBO (combo), TRUE, FALSE);

  cancel_button = gtk_dialog_add_button (GTK_DIALOG (dialog_window),
					 GTK_STOCK_CANCEL,
					 GTK_RESPONSE_CANCEL);

  open_button =
    gtk_dialog_add_button (GTK_DIALOG (dialog_window), GTK_STOCK_OK,
			   GTK_RESPONSE_OK);
 // gtk_container_set_border_width (GTK_CONTAINER
//				  (GTK_DIALOG (dialog_window)->vbox),
//				  gpe_get_border ());
//  gtk_box_set_spacing (GTK_BOX (GTK_DIALOG (dialog_window)->vbox),
//		       gpe_get_boxspacing ());
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->vbox), label, TRUE,
		      TRUE, 0);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->vbox), combo, TRUE,
		      TRUE, 0);
  GTK_WIDGET_SET_FLAGS (open_button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (open_button);

	if (vfs_file_info->mime_type)
  {
		DBG("MIME_TYPE=%s",vfs_file_info->mime_type);
		applications = gnome_vfs_application_registry_get_applications (vfs_file_info-> mime_type);
    if (applications)		/* translate list, get app info */
	  { 
	    GList *iter;
	    for (iter = applications; iter; iter = iter->next)
        iter->data = gnome_vfs_application_registry_get_mime_application (iter->data);
	  }
    else
	  applications = gnome_vfs_mime_get_short_list_applications (vfs_file_info->mime_type);
  }
  else
	{
	  DBG("NO MIME APPLICATIONS,find app by yourself");
		applications = gnome_vfs_mime_get_all_applications (vfs_file_info->mime_type);
	}

  /* fill combo with application names */
  if (applications)
  {
    GnomeVFSMimeApplication *app;
    GList *iter = applications;

    while (iter)
	  {
	    app = (GnomeVFSMimeApplication *) (iter->data);
	    appnames = g_list_append (appnames, app->name);
	    iter = iter->next;
	  }
    gtk_combo_set_popdown_strings (GTK_COMBO (combo), appnames);
  }
  else
  {
    gchar *s;
    gtk_widget_set_sensitive (combo, FALSE);
    gtk_widget_set_sensitive (open_button, FALSE);

    s = g_strdup_printf ("<b>%s</b>", "No available applications");
    gtk_label_set_markup (GTK_LABEL (label), s);
    g_free (s);
  }

  gtk_widget_show_all (dialog_window);

  /* run dialog */
  if (gtk_dialog_run (GTK_DIALOG (dialog_window)) == GTK_RESPONSE_OK)
  {
    GnomeVFSMimeApplication *app;
    GList *iter = applications;
    const gchar *selected_app =	gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (combo)->entry));

    while (iter)
	 {
	   app = (GnomeVFSMimeApplication *) (((GList *) iter)->data);

	  if (!strcmp (selected_app, app->name))
	  {
			  open_with (app, file_name);
	      break;
	  }
	  iter = iter->next;
	}
}
  g_free(file_name);
  gtk_widget_destroy (dialog_window);
  g_list_free (appnames);



}

static void 
ok_open_file(GtkWidget *filechooser,gpointer user_data)
{
  popup_ask_open_file(NULL,filechooser);
}

static void
popup_ask_delete_file(GtkActionGroup *action_group,gpointer user_data)
{
	GList *sel = NULL;
	sel = gem_file_chooser_get_current_selections_vfs_file_info(user_data);
	if(sel ==  NULL)
		return;
	g_list_foreach(sel,(GFunc)delete_one_file,user_data);
	
	const gchar *current_path = gem_file_chooser_get_current_path(user_data);
  gem_file_chooser_set_current_path(user_data,current_path);
}

static void
delete_one_file (gpointer data,gpointer user_data)
{
  gboolean isdir;
  GnomeVFSURI *uri;
  GnomeVFSResult r;
	GnomeVFSFileInfo *vfs_file_info =  NULL;
	vfs_file_info = data;
	const gchar *absolute_path = gem_file_chooser_get_current_path(user_data);
  gchar *file_name = g_strdup_printf("%s/%s",absolute_path,vfs_file_info->name);
  DBG("file_name=%s",file_name);
	if (vfs_file_info)
  {
    isdir = (vfs_file_info->type == GNOME_VFS_FILE_TYPE_DIRECTORY);
    if (isdir)
	  {  
	     DBG("is dir");
       r = delete_directory_recursive (file_name);
    }
    else
	  {
	    DBG("not dir");
			uri = gnome_vfs_uri_new (file_name);
	    r = gnome_vfs_unlink_from_uri (uri);
	    gnome_vfs_uri_unref (uri);
	  }
    if (r != GNOME_VFS_OK)
	  { 
       DBG(gnome_vfs_result_to_string (r));
    }
		else
	  {
		  DBG(gnome_vfs_result_to_string (r));
		}
  }
  DBG("free file name:%s",file_name);
	g_free(file_name);
//  DBG("after free:%s",file_name);

}

gboolean
delete_cb_recursive ( const gchar * rel_path,
	              	    GnomeVFSFileInfo * info,
              		    gboolean recursing_will_loop,
		                  gpointer data, 
											gboolean * recurse
										)
{
  gchar *path = data;
  gchar *fn = g_strdup_printf ("%s/%s", path, rel_path);
  if (info->type == GNOME_VFS_FILE_TYPE_DIRECTORY)
  {
    *recurse = TRUE;
    GnomeVFSResult r = 0;
    if (!recursing_will_loop)
     	r = gnome_vfs_directory_visit ( fn, GNOME_VFS_FILE_INFO_DEFAULT,
                       				        GNOME_VFS_DIRECTORY_VISIT_DEFAULT,
                      				        (GnomeVFSDirectoryVisitFunc)delete_cb_recursive, 
                                      strdup (fn)
                                    );
      /* HACK: We collect the empty directories in a list to delete after 
         visiting the complete tree to prevent gnome-vfs from stopping
         visiting directories 
       */
    if (r == GNOME_VFS_OK)
   	{
      dirlist = g_list_append (dirlist, fn);
			DBG("DELETE FN=%s",fn);
	  }
    else
	  {
      fprintf (stderr, "Err %s\n", gnome_vfs_result_to_string (r));
    }
  }
  else
  {
     gnome_vfs_unlink_from_uri (gnome_vfs_uri_new (fn));
     g_free (fn);
  }
  return TRUE;
}

static void
popup_copy_file_clip(GtkActionGroup *action_group,gpointer user_data)
{
  clear_clipboard();
	GList *sel = NULL;
	sel = gem_file_chooser_get_current_selections_vfs_file_info(user_data);
	if(sel ==  NULL)
		return;
	g_list_foreach(sel,(GFunc)clip_one_file,user_data);
	gem_file_chooser_set_selectable(user_data,FALSE);
}

static void
clip_one_file (gpointer data,gpointer user_data)
{
  GnomeVFSFileInfo *vfs_file_info = data;
	const gchar *absolute_path = gem_file_chooser_get_current_path(user_data);
  gchar *file_path = g_strdup_printf("%s/%s",absolute_path,vfs_file_info->name);
 	if (vfs_file_info)
  {				//handle local file,filename prefix is file://
    if (GNOME_VFS_FILE_INFO_LOCAL (vfs_file_info))
	  {
	    file_clipboard = g_list_append (file_clipboard,  gnome_vfs_get_uri_from_local_path (file_path) +  7);
	  }
    else
	    file_clipboard = g_list_append (file_clipboard, g_strdup (file_path));
  }
	g_free(file_path);
}
void paste_file_clip(GtkActionGroup *action_group, gpointer data)
{
  if (file_clipboard == NULL)
    return;
  const gchar *dest_dir = gem_file_chooser_get_current_path(data);
	g_list_foreach (file_clipboard,(GFunc)copy_one_file,data);
  gem_file_chooser_set_current_path(data,dest_dir);
}



void
copy_file (const gchar * src_uri_txt, const gchar * dest_uri_txt)
{
  GnomeVFSURI *uri_src = gnome_vfs_uri_new (src_uri_txt);
  GnomeVFSURI *uri_dest = gnome_vfs_uri_new (dest_uri_txt);
  GnomeVFSResult result;
  gchar *error;
  
	
  result = gnome_vfs_xfer_uri (uri_src,
			       uri_dest,
			       GNOME_VFS_XFER_FOLLOW_LINKS
			       | GNOME_VFS_XFER_RECURSIVE
			       | GNOME_VFS_XFER_EMPTY_DIRECTORIES,
			       GNOME_VFS_XFER_ERROR_MODE_QUERY,
			       GNOME_VFS_XFER_OVERWRITE_MODE_QUERY,
			       (GnomeVFSXferProgressCallback)
			       transfer_callback, NULL);

  if ((result != GNOME_VFS_OK) && (result != GNOME_VFS_ERROR_INTERRUPTED))
  {
    error = g_strdup_printf ("%s",gnome_vfs_result_to_string (result));
    DBG("ERROR:::%s",error);
	  g_free (error);
  }
  else
  {
    //gpe_popup_infoprint (GDK_DISPLAY (), _("File copied."));
		DBG("Flie Copied");
  }
  gnome_vfs_uri_unref (uri_src);
  gnome_vfs_uri_unref (uri_dest);
}
static void
copy_one_file (gpointer file, gpointer userdata)
{
  gchar *target_file;
  GnomeVFSFileInfo *src_info = gnome_vfs_file_info_new ();
  GnomeVFSResult result = gnome_vfs_get_file_info(file,src_info,GNOME_VFS_FILE_INFO_DEFAULT);
	if(result == GNOME_VFS_OK)
		DBG("read OK");				
  if((src_info->type == GNOME_VFS_FILE_TYPE_DIRECTORY))
	  DBG("IS DIR");	
	const gchar *current_directory = gem_file_chooser_get_current_path(userdata);
  
  DBG("src_file=%s",file);
	if((result == GNOME_VFS_OK) && (src_info->type == GNOME_VFS_FILE_TYPE_DIRECTORY))
	{
	  DBG("LET US CHECK STH");
		if(g_strrstr(current_directory,file)!=NULL)
		{
		   DBG("can not be copyied to itself");
			 return;
		}
	}
	DBG("current_directory=%s",current_directory);
  DBG("base name=%s",g_path_get_basename (file));
	target_file =	g_strdup_printf ("%s/%s", current_directory, g_path_get_basename (file));
  DBG("target_file=%s",target_file);
	//we need to find a name for the copy... 
  target_file = g_strdup (get_the_copy_name (target_file));
  
  copy_file (file, target_file);
  g_free (target_file);
}

static gint
transfer_callback (GnomeVFSXferProgressInfo * info, gpointer data)
{
  GtkWidget *dialog;
  GtkWidget *label;
  gchar *text;
  int response;
  gboolean applytoall;

  window = gtk_window_new(GTK_WINDOW_POPUP);
  if (abort_transfer)
  {
    gtk_widget_destroy (progress_dialog);
    progress_dialog = NULL;
    abort_transfer = FALSE;
    return 0;
  }
  switch (info->status)
  {
    case GNOME_VFS_XFER_PROGRESS_STATUS_OK:
         if (progress_dialog == NULL)
       	   progress_dialog = progress_dialog_create ("Transfer progress");
         else if (info->bytes_total)
	       {
	         GtkWidget *bar = g_object_get_data (G_OBJECT (progress_dialog), "bar");
	         gtk_progress_bar_set_fraction ( GTK_PROGRESS_BAR (bar),
					                                 (gdouble) info->total_bytes_copied /(gdouble)(info->bytes_total)
																				 );
	       }
         if (info->phase == GNOME_VFS_XFER_PHASE_COMPLETED)
	       {
	          gtk_widget_destroy (progress_dialog);
	          progress_dialog = NULL;
	       }
         gtk_main_iteration_do (FALSE);
         return 1;
    break;
    case GNOME_VFS_XFER_PROGRESS_STATUS_VFSERROR:
      /* error query dialog */

          text = g_strdup_printf ("%s %s", "Error:",
			    gnome_vfs_result_to_string (info->vfs_status));
          dialog = gtk_dialog_new_with_buttons ( "Error", GTK_WINDOW (window),
					                                        GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
					                                        "_Skip", GTK_RESPONSE_HELP,
                                    					    "_Retry", GTK_RESPONSE_APPLY,
                                    					    GTK_STOCK_CANCEL,
                                         			    GTK_RESPONSE_CANCEL, NULL
																								);
          label = gtk_label_new (text);
          g_free (text);
          gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
          gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), label, FALSE, TRUE, 0);
          gtk_widget_show_all (dialog);
          response = gtk_dialog_run (GTK_DIALOG (dialog));
          gtk_widget_destroy (dialog);
          switch (response)
	        {
	          case   GTK_RESPONSE_CANCEL:
	                 gtk_widget_destroy (progress_dialog);
	                 progress_dialog = NULL;
	                 return GNOME_VFS_XFER_ERROR_ACTION_ABORT;
	          break;
	          case   GTK_RESPONSE_HELP:
	                 return GNOME_VFS_XFER_ERROR_ACTION_SKIP;
	          break;
	          case   GTK_RESPONSE_APPLY:
	                 return GNOME_VFS_XFER_ERROR_ACTION_RETRY;
	          break;
	          default:
	                 gtk_widget_destroy (progress_dialog);
	                 progress_dialog = NULL;
	                 return GNOME_VFS_XFER_ERROR_ACTION_ABORT;
	          break;
	        }
    break;
    case GNOME_VFS_XFER_PROGRESS_STATUS_OVERWRITE:
      /* overwrite query dialog */
         text = g_strdup_printf ("Overwrite file:\n%s", info->target_name);
         dialog =  gtk_dialog_new_with_buttons ("File exists", GTK_WINDOW (window),
				                                          GTK_DIALOG_MODAL |
                            				              GTK_DIALOG_DESTROY_WITH_PARENT,
                                                  GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                       			      GTK_STOCK_YES, GTK_RESPONSE_YES,
                                      			      GTK_STOCK_NO, GTK_RESPONSE_NO, NULL);
          label = gtk_label_new (text);
          g_free (text);
          gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), label, FALSE, TRUE, 0);
          label = gtk_check_button_new_with_label ("Apply to all");
          gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (label), FALSE);
          gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), label, FALSE, TRUE, 0);
          gtk_widget_show_all (dialog);
          response = gtk_dialog_run (GTK_DIALOG (dialog));
          applytoall = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (label));
          gtk_widget_destroy (dialog);
          switch (response)
	        {
	          case  GTK_RESPONSE_CANCEL:
	                gtk_widget_destroy (progress_dialog);
	                progress_dialog = NULL;
	                return GNOME_VFS_XFER_OVERWRITE_ACTION_ABORT;
               	  break;
          	case  GTK_RESPONSE_YES:
                  if (applytoall)
            	      return GNOME_VFS_XFER_OVERWRITE_ACTION_REPLACE_ALL;
	                else
	                  return GNOME_VFS_XFER_OVERWRITE_ACTION_REPLACE;
	                break;
          	case  GTK_RESPONSE_NO:
	                if (applytoall)
	                  return GNOME_VFS_XFER_OVERWRITE_ACTION_SKIP_ALL;
	                else
	                  return GNOME_VFS_XFER_OVERWRITE_ACTION_SKIP;
	                break;
	          default:
	                gtk_widget_destroy (progress_dialog);
	                progress_dialog = NULL;
	                return GNOME_VFS_XFER_OVERWRITE_ACTION_ABORT;
	           break;
	         }
    break;
    default:
           return 1;			/* we should never get there */
           break;
  }
}
const gchar *
get_the_copy_name (gchar * the_copy_name)
{
  gint i = 1;
  const char *rbracket = "(";
  const char *dot = ".";
  gchar *tt, *ext;
  gchar *basename, *temp = NULL;
  basename = g_strdup (the_copy_name);
  ext = g_strrstr (basename, dot);
  if (ext != NULL)
  {
    *ext = '\0';
    ext++;
  }
  tt = g_strrstr (basename, rbracket);
  if (tt != NULL)
  {
    *tt = '\0';
  }

  GnomeVFSURI *uri = gnome_vfs_uri_new (the_copy_name);
  while (TRUE)
  {
    if ((gnome_vfs_uri_exists (uri)))
	  {
	    if (ext)
	      temp = g_strdup_printf ("%s(%d).%s", basename, i, ext);
	    else
	      temp = g_strdup_printf ("%s(%d)", basename, i);
	    i++;
	    uri = gnome_vfs_uri_new (temp);
	    g_free (temp);
	  }
    else
	  {
	    break;
	  }
  }
  g_free (basename);
  g_free (the_copy_name);
  return gnome_vfs_uri_get_path (uri);
}
void 
multi_select_enable(GtkActionGroup *action_group,gpointer data)
{
  MARK=~MARK;
  gem_file_chooser_set_selectable(data,MARK);
  return;
}
#if BLUETOOTH
static gchar *menu_item = " \
	<ui>\
		<popup  action=\"PopupLeft\">\
			<menuitem name=\"copy\"		        	 action=\"copy_file_or_dir\"/>\
			<menuitem name=\"paste\"			       action=\"paste_file_or_dir\"/>\
			<menuitem name=\"move\"		           action=\"move_file_or_dir\"/>\
			<menuitem name=\"rename\"			       action=\"rename_file_or_dir\"/>\
			<menuitem name=\"delete\"			       action=\"delete_file_or_dir\"/>\
			<menuitem name=\"creat_dir\"			   action=\"creat_new_dir\"/>\
			<menuitem name=\"select_all\"			   action=\"select_all\"/>\
			<menuitem name=\"select_all\"			   action=\"select_all\"/>\
			<menuitem name=\"send_via_bluetooth\"			action=\"send_via_bluetooth\"/>\
			<menuitem name=\"send_via_infrared\"			action=\"send_via_infrared\"/>\
		</popup>\
	</ui>\
";

static GtkActionEntry menu_actions[] = {
  {"copy_file_or_dir"   , NULL, "_Copy"              , "", "none", popup_copy_file_clip},
  {"paste_file_or_dir"  , NULL, "_Paste"             , "", "none", paste_file_clip},
  {"move_file_or_dir"   , NULL, "_Move"              , "", "none", popup_ask_move_file},
  {"rename_file_or_dir" , NULL, "_Rename"            , "", "none", popup_ask_rename_file},
  {"delete_file_or_dir" , NULL, "_Delete"            , "", "none", popup_ask_delete_file},
  {"creat_new_dir"      , NULL, "_Create"            , "", "none", create_directory_interactive},
  {"select_all"         , NULL, "_Select All"        , "", "none", do_select_all},
  {"send_via_bluetooth" , NULL, "_Send via Bluetooth", "", "none", send_with_bluetooth},
  {"send_via_infrared"  , NULL, "_Send via Infrared" , "", "none", send_with_irda},
  {"PopupLeft"          , NULL, "Popup"              , "", "none", NULL},
};
#else
static gchar *menu_item = " \
	<ui>\
		<popup  action=\"PopupLeft\">\
			<menuitem name=\"open\"		        	 action=\"open_file_or_dir\"/>\
			<menuitem name=\"copy\"		        	 action=\"copy_file_or_dir\"/>\
			<menuitem name=\"paste\"			       action=\"paste_file_or_dir\"/>\
			<menuitem name=\"delete\"			       action=\"delete_file_or_dir\"/>\
			<menuitem name=\"select\"   			   action=\"select\"/>\
		</popup>\
	</ui>\
";
static GtkActionEntry menu_actions[] = {
  {"open_file_or_dir"   , NULL, "Open"              , "", "open"   , popup_ask_open_file},
  {"copy_file_or_dir"   , NULL, "Copy"              , "", "copy"   , popup_copy_file_clip},
  {"paste_file_or_dir"  , NULL, "Paste"             , "", "paste"  , paste_file_clip},
  {"delete_file_or_dir" , NULL, "Delete"            , "", "delete" , popup_ask_delete_file},
  {"select"             , NULL, "Mark/Unmark"       , "", "mark"   , multi_select_enable},
  {"PopupLeft"          , NULL, "Popup"             , "", "none"   , NULL},
};

#endif 

int main( int   argc,
          char *argv[] )
{
  gtk_init (&argc, &argv);
  GtkWidget *vbox = NULL; 
 
  GtkWidget *fchooser = NULL;
  GError *error = NULL;
   
  window = gpe_skwindow_new ();
  vbox = gtk_vbox_new(FALSE, 0);
  fchooser = gem_file_chooser_new ();
  gem_file_chooser_set_current_path(fchooser,"vroot://music");
  gtk_box_pack_start ( GTK_BOX (vbox),
                           fchooser,
                            TRUE,
                            TRUE,
                             0);
  g_signal_connect( GTK_WIDGET(fchooser),
	                  "file_selected",
	                  G_CALLBACK(ok_open_file),
			              NULL);

  gtk_container_add (GTK_CONTAINER (window), vbox);
  
	action_group = gtk_action_group_new ("Actions");
  ui_manager = gtk_ui_manager_new ();
  gtk_action_group_add_actions (action_group,	menu_actions,	G_N_ELEMENTS (menu_actions), fchooser);

  gtk_ui_manager_insert_action_group (ui_manager, action_group, 0);
  if (!gtk_ui_manager_add_ui_from_string (GTK_UI_MANAGER (ui_manager), menu_item, -1, &error))
  {
    g_printerr ("Failed to parse menu data: %s\n", error->message);
    g_error_free (error);
    return 0;
  }
  
   gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), 1, _("Backkkkk"));
   gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), 0, _("Option"));
   /* test DBUS alive? */
   {
     gchar *env = getenv ("DBUS_SESSION_BUS_ADDRESS");
     if (env)
     {
	     gchar *db_skt;
 	     /* env format:  unix:abstract=/tmp/dbus-oPDqe55s2c,guid=58c26446325920ef5440736a57f10100 */
	     db_skt = strchr (env, '=');
	     if (db_skt && strstr (db_skt + 1, "/tmp/"))	/* the socket file might not exist! */
       {
	       GtkWidget *sk_menu = gtk_ui_manager_get_widget (ui_manager, "/PopupLeft");
	       gpe_skwindow_set_softkey_menu (GPE_SKWINDOW (window), 0, sk_menu);
  	     gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), 0, _("Option"));
         gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), 1, _("Exitttt"));
         g_signal_connect (GPE_SKWINDOW (window), "softkey_activated", G_CALLBACK (cb_softkey_action), fchooser);
	     }
	     else
	     {
	       g_print ("DBUS might not be running, pls check it.\n");
	     }
     }
     else
     {
	     g_print ("DBUS might not be running, pls check it.\n");
     }
   }
  
   gtk_signal_connect (GTK_OBJECT (window), "delete-event", GTK_SIGNAL_FUNC (gtk_exit), NULL);
   gtk_widget_realize (window);
   
   gtk_widget_show_all (window);
   gtk_main ();
}
